;MACROS .if,.while,.repeat,invoke...
comment * Comparison run-time operators

     Operator      Meaning
 
     ==            Equal
     {}            Not equal
     }             Greater than
     }=            Greater than or equal to
     {             Less than
     {=            Less than or equal to
     &             Bit test (format: expression & bitnumber)
     ~             Logical NOT
     |	         Bit test
     &&            Logical AND

     ||            Logical OR
 
     CARRY?        Carry bit set
     OVERFLOW?     Overflow bit set
     PARITY?       Parity bit set
     SIGN?         Sign bit set
     ZERO?         Zero bit set
     ZERO?|PARITY?
     CARRY?|ZERO?
     CARRY?&ZERO?
     ~ZERO?&(SIGN?==OVERFLOW?)	(greate than)
     SIGN?==OVERFLOW?		(greate than or equal)
     SIGN?{}OVERFLOW?		(less than)
     ZERO?|(SIGN?{}OVERFLOW?)	(less than or equal)
*
IFNDEF retn
getsec MACRO
	dw 370Fh
ENDM
retn MACRO stackBytes
	IFIDN <stackBytes>,<>
		db 0C3h
	ELSE
		db 0C2h
		dw stackBytes
	ENDIF
ENDM
retnw MACRO stackBytes
	db 66h
	retn stackBytes
ENDM
enterw MACRO toStackRes,lvlEmb
	dw 0C866h,toStackRes
	db lvlEmb
ENDM
leavew MACRO
	dw 0C966h
ENDM
ENDIF
TotalIfs = 0
TotalRept = 0
TotalWhile = 0
UntilConds0 TEXTEQU <>
UntilConds1 TEXTEQU <>
UntilConds2 TEXTEQU <>
UntilConds3 TEXTEQU <>
UntilConds4 TEXTEQU <>
UntilConds5 TEXTEQU <>
UntilConds6 TEXTEQU <>
UntilConds7 TEXTEQU <>
UntilConds8 TEXTEQU <>
UntilConds9 TEXTEQU <>
UntilConds10 TEXTEQU <>
UntilConds11 TEXTEQU <>
UntilConds12 TEXTEQU <>
UntilConds13 TEXTEQU <>
UntilConds14 TEXTEQU <>
UntilConds15 TEXTEQU <>
UntilConds16 TEXTEQU <>
UntilConds17 TEXTEQU <>
UntilConds18 TEXTEQU <>
UntilConds19 TEXTEQU <>
LastUntilConds TEXTEQU <>
SaveUntilCondsLabel MACRO
	IFIDN UntilConds0,<>
		UntilConds0 CATSTR <locconds0_>,@CatStr(%TotalWhile)
		LastUntilConds TEXTEQU UntilConds0
	ELSEIFIDN UntilConds1,<> 
		UntilConds1 CATSTR <locconds1_>,@CatStr(%TotalWhile)
		LastUntilConds TEXTEQU UntilConds1
	ELSEIFIDN UntilConds2,<> 
		UntilConds2 CATSTR <locconds2_>,@CatStr(%TotalWhile)
		LastUntilConds TEXTEQU UntilConds2
	ELSEIFIDN UntilConds3,<> 
		UntilConds3 CATSTR <locconds3_>,@CatStr(%TotalWhile)
		LastUntilConds TEXTEQU UntilConds3
	ELSEIFIDN UntilConds4,<> 
		UntilConds4 CATSTR <locconds4_>,@CatStr(%TotalWhile)
		LastUntilConds TEXTEQU UntilConds4
	ELSEIFIDN UntilConds5,<> 
		UntilConds5 CATSTR <locconds5_>,@CatStr(%TotalWhile)
		LastUntilConds TEXTEQU UntilConds5
	ELSEIFIDN UntilConds6,<> 
		UntilConds6 CATSTR <locconds6_>,@CatStr(%TotalWhile)
		LastUntilConds TEXTEQU UntilConds6
	ELSEIFIDN UntilConds7,<> 
		UntilConds7 CATSTR <locconds7_>,@CatStr(%TotalWhile)
		LastUntilConds TEXTEQU UntilConds7
	ELSEIFIDN UntilConds8,<> 
		UntilConds8 CATSTR <locconds8_>,@CatStr(%TotalWhile)
		LastUntilConds TEXTEQU UntilConds8
	ELSEIFIDN UntilConds9,<> 
		UntilConds9 CATSTR <locconds9_>,@CatStr(%TotalWhile)
		LastUntilConds TEXTEQU UntilConds9
	ELSEIFIDN UntilConds10,<>
		UntilConds10 CATSTR <locconds10_>,@CatStr(%TotalWhile)
		LastUntilConds TEXTEQU UntilConds10
	ELSEIFIDN UntilConds11,<> 
		UntilConds11 CATSTR <locconds11_>,@CatStr(%TotalWhile)
		LastUntilConds TEXTEQU UntilConds11
	ELSEIFIDN UntilConds12,<> 
		UntilConds12 CATSTR <locconds12_>,@CatStr(%TotalWhile)
		LastUntilConds TEXTEQU UntilConds12
	ELSEIFIDN UntilConds13,<> 
		UntilConds13 CATSTR <locconds13_>,@CatStr(%TotalWhile)
		LastUntilConds TEXTEQU UntilConds13
	ELSEIFIDN UntilConds14,<> 
		UntilConds14 CATSTR <locconds14_>,@CatStr(%TotalWhile)
		LastUntilConds TEXTEQU UntilConds14
	ELSEIFIDN UntilConds15,<> 
		UntilConds15 CATSTR <locconds15_>,@CatStr(%TotalWhile)
		LastUntilConds TEXTEQU UntilConds15
	ELSEIFIDN UntilConds16,<> 
		UntilConds16 CATSTR <locconds16_>,@CatStr(%TotalWhile)
		LastUntilConds TEXTEQU UntilConds16
	ELSEIFIDN UntilConds17,<> 
		UntilConds17 CATSTR <locconds17_>,@CatStr(%TotalWhile)
		LastUntilConds TEXTEQU UntilConds17
	ELSEIFIDN UntilConds18,<> 
		UntilConds18 CATSTR <locconds18_>,@CatStr(%TotalWhile)
		LastUntilConds TEXTEQU UntilConds18
	ELSEIFIDN UntilConds19,<> 
		UntilConds19 CATSTR <locconds19_>,@CatStr(%TotalWhile)
		LastUntilConds TEXTEQU UntilConds19
	ELSE
		.err .ifs error
	ENDIF
	TotalWhile = TotalWhile+1
ENDM
GetUntilCondsLabel MACRO
	IFDIF UntilConds19,<>
		LastUntilConds TEXTEQU UntilConds19
	ELSEIFDIF UntilConds18,<>
		LastUntilConds TEXTEQU UntilConds18
	ELSEIFDIF UntilConds17,<>
		LastUntilConds TEXTEQU UntilConds17
	ELSEIFDIF UntilConds16,<>
		LastUntilConds TEXTEQU UntilConds16
	ELSEIFDIF UntilConds15,<>
		LastUntilConds TEXTEQU UntilConds15
	ELSEIFDIF UntilConds14,<>
		LastUntilConds TEXTEQU UntilConds14
	ELSEIFDIF UntilConds13,<>
		LastUntilConds TEXTEQU UntilConds13	
	ELSEIFDIF UntilConds12,<>
		LastUntilConds TEXTEQU UntilConds12
	ELSEIFDIF UntilConds11,<>
		LastUntilConds TEXTEQU UntilConds11	
	ELSEIFDIF UntilConds10,<>
		LastUntilConds TEXTEQU UntilConds10
	ELSEIFDIF UntilConds9,<>
		LastUntilConds TEXTEQU UntilConds9
	ELSEIFDIF UntilConds8,<>
		LastUntilConds TEXTEQU UntilConds8
	ELSEIFDIF UntilConds7,<>
		LastUntilConds TEXTEQU UntilConds7
	ELSEIFDIF UntilConds6,<>
		LastUntilConds TEXTEQU UntilConds6
	ELSEIFDIF UntilConds5,<>
		LastUntilConds TEXTEQU UntilConds5
	ELSEIFDIF UntilConds4,<>
		LastUntilConds TEXTEQU UntilConds4
	ELSEIFDIF UntilConds3,<>
		LastUntilConds TEXTEQU UntilConds3	
	ELSEIFDIF UntilConds2,<>
		LastUntilConds TEXTEQU UntilConds2
	ELSEIFDIF UntilConds1,<>
		LastUntilConds TEXTEQU UntilConds1	
	ELSEIFDIF UntilConds0,<>
		LastUntilConds TEXTEQU UntilConds0
	ELSE
		LastUntilConds TEXTEQU <>
	ENDIF		
ENDM
DelUntilCondsLabel MACRO
	IFDIF UntilConds19,<>
		UntilConds19 TEXTEQU <>
	ELSEIFDIF UntilConds18,<>
		UntilConds18 TEXTEQU <>
	ELSEIFDIF UntilConds17,<>
		UntilConds17 TEXTEQU <>
	ELSEIFDIF UntilConds16,<>
		UntilConds16 TEXTEQU <>
	ELSEIFDIF UntilConds15,<>
		UntilConds15 TEXTEQU <>
	ELSEIFDIF UntilConds14,<>
		UntilConds14 TEXTEQU <>
	ELSEIFDIF UntilConds13,<>
		UntilConds13 TEXTEQU <>	
	ELSEIFDIF UntilConds12,<>
		UntilConds12 TEXTEQU <>
	ELSEIFDIF UntilConds11,<>
		UntilConds11 TEXTEQU <>	
	ELSEIFDIF UntilConds10,<>
		UntilConds10 TEXTEQU <>
	ELSEIFDIF UntilConds9,<>
		UntilConds9 TEXTEQU <>
	ELSEIFDIF UntilConds8,<>
		UntilConds8 TEXTEQU <>
	ELSEIFDIF UntilConds7,<>
		UntilConds7 TEXTEQU <>
	ELSEIFDIF UntilConds6,<>
		UntilConds6 TEXTEQU <>
	ELSEIFDIF UntilConds5,<>
		UntilConds5 TEXTEQU <>
	ELSEIFDIF UntilConds4,<>
		UntilConds4 TEXTEQU <>
	ELSEIFDIF UntilConds3,<>
		UntilConds3 TEXTEQU <>	
	ELSEIFDIF UntilConds2,<>
		UntilConds2 TEXTEQU <>
	ELSEIFDIF UntilConds1,<>
		UntilConds1 TEXTEQU <>	
	ELSEIFDIF UntilConds0,<>
		UntilConds0 TEXTEQU <>
	ENDIF
ENDM
WhileLevel0 TEXTEQU <>
WhileLevel1 TEXTEQU <>
WhileLevel2 TEXTEQU <>
WhileLevel3 TEXTEQU <>
WhileLevel4 TEXTEQU <>
WhileLevel5 TEXTEQU <>
WhileLevel6 TEXTEQU <>
WhileLevel7 TEXTEQU <>
WhileLevel8 TEXTEQU <>
WhileLevel9 TEXTEQU <>
WhileLevel10 TEXTEQU <>
WhileLevel11 TEXTEQU <>
WhileLevel12 TEXTEQU <>
WhileLevel13 TEXTEQU <>
WhileLevel14 TEXTEQU <>
WhileLevel15 TEXTEQU <>
WhileLevel16 TEXTEQU <>
WhileLevel17 TEXTEQU <>
WhileLevel18 TEXTEQU <>
WhileLevel19 TEXTEQU <>
LastWhileConds TEXTEQU <>
SaveWhileConds MACRO args:VARARG
	IFIDN WhileLevel0,<>
		WhileLevel0 TEXTEQU <args>
		LastWhileConds TEXTEQU <args>
	ELSEIFIDN WhileLevel1,<> 
		WhileLevel2 TEXTEQU <args>
		LastWhileConds TEXTEQU <args>
	ELSEIFIDN WhileLevel2,<> 
		WhileLevel2 TEXTEQU <args>
		LastWhileConds TEXTEQU <args>
	ELSEIFIDN WhileLevel3,<> 
		WhileLevel3 TEXTEQU args
		LastWhileConds TEXTEQU WhileLevel3
	ELSEIFIDN WhileLevel4,<> 
		WhileLevel4 CATSTR TEXTEQU <args>
		LastWhileConds TEXTEQU WhileLevel4
	ELSEIFIDN WhileLevel5,<> 
		WhileLevel5 TEXTEQU <args>
		LastWhileConds TEXTEQU WhileLevel5
	ELSEIFIDN WhileLevel6,<> 
		WhileLevel6 TEXTEQU <args>
		LastWhileConds TEXTEQU WhileLevel6
	ELSEIFIDN WhileLevel7,<> 
		WhileLevel7 TEXTEQU <args>
		LastWhileConds TEXTEQU WhileLevel7
	ELSEIFIDN WhileLevel8,<> 
		WhileLevel8 TEXTEQU <args>
		LastWhileConds TEXTEQU WhileLevel8
	ELSEIFIDN WhileLevel9,<> 
		WhileLevel9 TEXTEQU <args>
		LastWhileConds TEXTEQU WhileLevel9
	ELSEIFIDN WhileLevel10,<>
		WhileLevel10 TEXTEQU <args>
		LastWhileConds TEXTEQU WhileLevel10
	ELSEIFIDN WhileLevel11,<> 
		WhileLevel11 TEXTEQU <args>
		LastWhileConds TEXTEQU WhileLevel11
	ELSEIFIDN WhileLevel12,<> 
		WhileLevel12 TEXTEQU <args>
		LastWhileConds TEXTEQU WhileLevel12
	ELSEIFIDN WhileLevel13,<> 
		WhileLevel13 TEXTEQU <args>
		LastWhileConds TEXTEQU WhileLevel13
	ELSEIFIDN WhileLevel14,<> 
		WhileLevel14 TEXTEQU <args>
		LastWhileConds TEXTEQU WhileLevel14
	ELSEIFIDN WhileLevel15,<> 
		WhileLevel15 TEXTEQU <args>
		LastWhileConds TEXTEQU WhileLevel15
	ELSEIFIDN WhileLevel16,<> 
		WhileLevel16 TEXTEQU <args>
		LastWhileConds TEXTEQU WhileLevel16
	ELSEIFIDN WhileLevel17,<> 
		WhileLevel17 TEXTEQU <args>
		LastWhileConds TEXTEQU WhileLevel17
	ELSEIFIDN WhileLevel18,<> 
		WhileLevel18 TEXTEQU <args>
		LastWhileConds TEXTEQU WhileLevel18
	ELSEIFIDN WhileLevel19,<> 
		WhileLevel19 TEXTEQU <args>
		LastWhileConds TEXTEQU WhileLevel19
	ELSE
		.err .ifs error
	ENDIF
ENDM
GetWhileConds MACRO
	IFDIF WhileLevel19,<>
		LastWhileConds TEXTEQU WhileLevel19
	ELSEIFDIF WhileLevel18,<>
		LastWhileConds TEXTEQU WhileLevel18
	ELSEIFDIF WhileLevel17,<>
		LastWhileConds TEXTEQU WhileLevel17
	ELSEIFDIF WhileLevel16,<>
		LastWhileConds TEXTEQU WhileLevel16
	ELSEIFDIF WhileLevel15,<>
		LastWhileConds TEXTEQU WhileLevel15
	ELSEIFDIF WhileLevel14,<>
		LastWhileConds TEXTEQU WhileLevel14
	ELSEIFDIF WhileLevel13,<>
		LastWhileConds TEXTEQU WhileLevel13	
	ELSEIFDIF WhileLevel12,<>
		LastWhileConds TEXTEQU WhileLevel12
	ELSEIFDIF WhileLevel11,<>
		LastWhileConds TEXTEQU WhileLevel11	
	ELSEIFDIF WhileLevel10,<>
		LastWhileConds TEXTEQU WhileLevel10
	ELSEIFDIF WhileLevel9,<>
		LastWhileConds TEXTEQU WhileLevel9
	ELSEIFDIF WhileLevel8,<>
		LastWhileConds TEXTEQU WhileLevel8
	ELSEIFDIF WhileLevel7,<>
		LastWhileConds TEXTEQU WhileLevel7
	ELSEIFDIF WhileLevel6,<>
		LastWhileConds TEXTEQU WhileLevel6
	ELSEIFDIF WhileLevel5,<>
		LastWhileConds TEXTEQU WhileLevel5
	ELSEIFDIF WhileLevel4,<>
		LastWhileConds TEXTEQU WhileLevel4
	ELSEIFDIF WhileLevel3,<>
		LastWhileConds TEXTEQU WhileLevel3	
	ELSEIFDIF WhileLevel2,<>
		LastWhileConds TEXTEQU WhileLevel2
	ELSEIFDIF WhileLevel1,<>
		LastWhileConds TEXTEQU WhileLevel1	
	ELSEIFDIF WhileLevel0,<>
		LastWhileConds TEXTEQU WhileLevel0
	ELSE
		LastWhileConds TEXTEQU <>
	ENDIF		
ENDM
DelWhileConds MACRO
	IFDIF WhileLevel19,<>
		WhileLevel19 TEXTEQU <>
	ELSEIFDIF WhileLevel18,<>
		WhileLevel18 TEXTEQU <>
	ELSEIFDIF WhileLevel17,<>
		WhileLevel17 TEXTEQU <>
	ELSEIFDIF WhileLevel16,<>
		WhileLevel16 TEXTEQU <>
	ELSEIFDIF WhileLevel15,<>
		WhileLevel15 TEXTEQU <>
	ELSEIFDIF WhileLevel14,<>
		WhileLevel14 TEXTEQU <>
	ELSEIFDIF WhileLevel13,<>
		WhileLevel13 TEXTEQU <>	
	ELSEIFDIF WhileLevel12,<>
		WhileLevel12 TEXTEQU <>
	ELSEIFDIF WhileLevel11,<>
		WhileLevel11 TEXTEQU <>	
	ELSEIFDIF WhileLevel10,<>
		WhileLevel10 TEXTEQU <>
	ELSEIFDIF WhileLevel9,<>
		WhileLevel9 TEXTEQU <>
	ELSEIFDIF WhileLevel8,<>
		WhileLevel8 TEXTEQU <>
	ELSEIFDIF WhileLevel7,<>
		WhileLevel7 TEXTEQU <>
	ELSEIFDIF WhileLevel6,<>
		WhileLevel6 TEXTEQU <>
	ELSEIFDIF WhileLevel5,<>
		WhileLevel5 TEXTEQU <>
	ELSEIFDIF WhileLevel4,<>
		WhileLevel4 TEXTEQU <>
	ELSEIFDIF WhileLevel3,<>
		WhileLevel3 TEXTEQU <>	
	ELSEIFDIF WhileLevel2,<>
		WhileLevel2 TEXTEQU <>
	ELSEIFDIF WhileLevel1,<>
		WhileLevel1 TEXTEQU <>	
	ELSEIFDIF WhileLevel0,<>
		WhileLevel0 TEXTEQU <>
	ENDIF
ENDM
UntilLevel0 TEXTEQU <>
UntilLevel1 TEXTEQU <>
UntilLevel2 TEXTEQU <>
UntilLevel3 TEXTEQU <>
UntilLevel4 TEXTEQU <>
UntilLevel5 TEXTEQU <>
UntilLevel6 TEXTEQU <>
UntilLevel7 TEXTEQU <>
UntilLevel8 TEXTEQU <>
UntilLevel9 TEXTEQU <>
UntilLevel10 TEXTEQU <>
UntilLevel11 TEXTEQU <>
UntilLevel12 TEXTEQU <>
UntilLevel13 TEXTEQU <>
UntilLevel14 TEXTEQU <>
UntilLevel15 TEXTEQU <>
UntilLevel16 TEXTEQU <>
UntilLevel17 TEXTEQU <>
UntilLevel18 TEXTEQU <>
UntilLevel19 TEXTEQU <>
LastUntilLabel TEXTEQU <>
SaveUntilLabel MACRO
	IFIDN UntilLevel0,<>
		UntilLevel0 CATSTR <locuntil0_>,@CatStr(%TotalRept)
		LastUntilLabel TEXTEQU UntilLevel0
	ELSEIFIDN UntilLevel1,<> 
		UntilLevel1 CATSTR <locuntil1_>,@CatStr(%TotalRept)
		LastUntilLabel TEXTEQU UntilLevel1
	ELSEIFIDN UntilLevel2,<> 
		UntilLevel2 CATSTR <locuntil2_>,@CatStr(%TotalRept)
		LastUntilLabel TEXTEQU UntilLevel2
	ELSEIFIDN UntilLevel3,<> 
		UntilLevel3 CATSTR <locuntil3_>,@CatStr(%TotalRept)
		LastUntilLabel TEXTEQU UntilLevel3
	ELSEIFIDN UntilLevel4,<> 
		UntilLevel4 CATSTR <locuntil4_>,@CatStr(%TotalRept)
		LastUntilLabel TEXTEQU UntilLevel4
	ELSEIFIDN UntilLevel5,<> 
		UntilLevel5 CATSTR <locuntil5_>,@CatStr(%TotalRept)
		LastUntilLabel TEXTEQU UntilLevel5
	ELSEIFIDN UntilLevel6,<> 
		UntilLevel6 CATSTR <locuntil6_>,@CatStr(%TotalRept)
		LastUntilLabel TEXTEQU UntilLevel6
	ELSEIFIDN UntilLevel7,<> 
		UntilLevel7 CATSTR <locuntil7_>,@CatStr(%TotalRept)
		LastUntilLabel TEXTEQU UntilLevel7
	ELSEIFIDN UntilLevel8,<> 
		UntilLevel8 CATSTR <locuntil8_>,@CatStr(%TotalRept)
		LastUntilLabel TEXTEQU UntilLevel8
	ELSEIFIDN UntilLevel9,<> 
		UntilLevel9 CATSTR <locuntil9_>,@CatStr(%TotalRept)
		LastUntilLabel TEXTEQU UntilLevel9
	ELSEIFIDN UntilLevel10,<>
		UntilLevel10 CATSTR <locuntil10_>,@CatStr(%TotalRept)
		LastUntilLabel TEXTEQU UntilLevel10
	ELSEIFIDN UntilLevel11,<> 
		UntilLevel11 CATSTR <locuntil11_>,@CatStr(%TotalRept)
		LastUntilLabel TEXTEQU UntilLevel11
	ELSEIFIDN UntilLevel12,<> 
		UntilLevel12 CATSTR <locuntil12_>,@CatStr(%TotalRept)
		LastUntilLabel TEXTEQU UntilLevel12
	ELSEIFIDN UntilLevel13,<> 
		UntilLevel13 CATSTR <locuntil13_>,@CatStr(%TotalRept)
		LastUntilLabel TEXTEQU UntilLevel13
	ELSEIFIDN UntilLevel14,<> 
		UntilLevel14 CATSTR <locuntil14_>,@CatStr(%TotalRept)
		LastUntilLabel TEXTEQU UntilLevel14
	ELSEIFIDN UntilLevel15,<> 
		UntilLevel15 CATSTR <locuntil15_>,@CatStr(%TotalRept)
		LastUntilLabel TEXTEQU UntilLevel15
	ELSEIFIDN UntilLevel16,<> 
		UntilLevel16 CATSTR <locuntil16_>,@CatStr(%TotalRept)
		LastUntilLabel TEXTEQU UntilLevel16
	ELSEIFIDN UntilLevel17,<> 
		UntilLevel17 CATSTR <locuntil17_>,@CatStr(%TotalRept)
		LastUntilLabel TEXTEQU UntilLevel17
	ELSEIFIDN UntilLevel18,<> 
		UntilLevel18 CATSTR <locuntil18_>,@CatStr(%TotalRept)
		LastUntilLabel TEXTEQU UntilLevel18
	ELSEIFIDN UntilLevel19,<> 
		UntilLevel19 CATSTR <locuntil19_>,@CatStr(%TotalRept)
		LastUntilLabel TEXTEQU UntilLevel19
	ELSE
		.err .ifs error
	ENDIF
	TotalRept = TotalRept+1
ENDM
GetUntilLabel MACRO
	IFDIF UntilLevel19,<>
		LastUntilLabel TEXTEQU UntilLevel19
	ELSEIFDIF UntilLevel18,<>
		LastUntilLabel TEXTEQU UntilLevel18
	ELSEIFDIF UntilLevel17,<>
		LastUntilLabel TEXTEQU UntilLevel17
	ELSEIFDIF UntilLevel16,<>
		LastUntilLabel TEXTEQU UntilLevel16
	ELSEIFDIF UntilLevel15,<>
		LastUntilLabel TEXTEQU UntilLevel15
	ELSEIFDIF UntilLevel14,<>
		LastUntilLabel TEXTEQU UntilLevel14
	ELSEIFDIF UntilLevel13,<>
		LastUntilLabel TEXTEQU UntilLevel13	
	ELSEIFDIF UntilLevel12,<>
		LastUntilLabel TEXTEQU UntilLevel12
	ELSEIFDIF UntilLevel11,<>
		LastUntilLabel TEXTEQU UntilLevel11	
	ELSEIFDIF UntilLevel10,<>
		LastUntilLabel TEXTEQU UntilLevel10
	ELSEIFDIF UntilLevel9,<>
		LastUntilLabel TEXTEQU UntilLevel9
	ELSEIFDIF UntilLevel8,<>
		LastUntilLabel TEXTEQU UntilLevel8
	ELSEIFDIF UntilLevel7,<>
		LastUntilLabel TEXTEQU UntilLevel7
	ELSEIFDIF UntilLevel6,<>
		LastUntilLabel TEXTEQU UntilLevel6
	ELSEIFDIF UntilLevel5,<>
		LastUntilLabel TEXTEQU UntilLevel5
	ELSEIFDIF UntilLevel4,<>
		LastUntilLabel TEXTEQU UntilLevel4
	ELSEIFDIF UntilLevel3,<>
		LastUntilLabel TEXTEQU UntilLevel3	
	ELSEIFDIF UntilLevel2,<>
		LastUntilLabel TEXTEQU UntilLevel2
	ELSEIFDIF UntilLevel1,<>
		LastUntilLabel TEXTEQU UntilLevel1	
	ELSEIFDIF UntilLevel0,<>
		LastUntilLabel TEXTEQU UntilLevel0
	ELSE
		LastUntilLabel TEXTEQU <>
	ENDIF		
ENDM
DelUntilLabel MACRO
	IFDIF UntilLevel19,<>
		UntilLevel19 TEXTEQU <>
	ELSEIFDIF UntilLevel18,<>
		UntilLevel18 TEXTEQU <>
	ELSEIFDIF UntilLevel17,<>
		UntilLevel17 TEXTEQU <>
	ELSEIFDIF UntilLevel16,<>
		UntilLevel16 TEXTEQU <>
	ELSEIFDIF UntilLevel15,<>
		UntilLevel15 TEXTEQU <>
	ELSEIFDIF UntilLevel14,<>
		UntilLevel14 TEXTEQU <>
	ELSEIFDIF UntilLevel13,<>
		UntilLevel13 TEXTEQU <>	
	ELSEIFDIF UntilLevel12,<>
		UntilLevel12 TEXTEQU <>
	ELSEIFDIF UntilLevel11,<>
		UntilLevel11 TEXTEQU <>	
	ELSEIFDIF UntilLevel10,<>
		UntilLevel10 TEXTEQU <>
	ELSEIFDIF UntilLevel9,<>
		UntilLevel9 TEXTEQU <>
	ELSEIFDIF UntilLevel8,<>
		UntilLevel8 TEXTEQU <>
	ELSEIFDIF UntilLevel7,<>
		UntilLevel7 TEXTEQU <>
	ELSEIFDIF UntilLevel6,<>
		UntilLevel6 TEXTEQU <>
	ELSEIFDIF UntilLevel5,<>
		UntilLevel5 TEXTEQU <>
	ELSEIFDIF UntilLevel4,<>
		UntilLevel4 TEXTEQU <>
	ELSEIFDIF UntilLevel3,<>
		UntilLevel3 TEXTEQU <>	
	ELSEIFDIF UntilLevel2,<>
		UntilLevel2 TEXTEQU <>
	ELSEIFDIF UntilLevel1,<>
		UntilLevel1 TEXTEQU <>	
	ELSEIFDIF UntilLevel0,<>
		UntilLevel0 TEXTEQU <>
	ENDIF
ENDM
TotalRept = 0
UntilOut0 TEXTEQU <>
UntilOut1 TEXTEQU <>
UntilOut2 TEXTEQU <>
UntilOut3 TEXTEQU <>
UntilOut4 TEXTEQU <>
UntilOut5 TEXTEQU <>
UntilOut6 TEXTEQU <>
UntilOut7 TEXTEQU <>
UntilOut8 TEXTEQU <>
UntilOut9 TEXTEQU <>
UntilOut10 TEXTEQU <>
UntilOut11 TEXTEQU <>
UntilOut12 TEXTEQU <>
UntilOut13 TEXTEQU <>
UntilOut14 TEXTEQU <>
UntilOut15 TEXTEQU <>
UntilOut16 TEXTEQU <>
UntilOut17 TEXTEQU <>
UntilOut18 TEXTEQU <>
UntilOut19 TEXTEQU <>
LastUntilOutLabel TEXTEQU <>
SaveUntilOutLabel MACRO
	IFIDN UntilOut0,<>
		UntilOut0 CATSTR <locuntilout0_>,@CatStr(%TotalRept)
		LastUntilOutLabel TEXTEQU UntilOut0
	ELSEIFIDN UntilOut1,<> 
		UntilOut1 CATSTR <locuntilout1_>,@CatStr(%TotalRept)
		LastUntilOutLabel TEXTEQU UntilOut1
	ELSEIFIDN UntilOut2,<> 
		UntilOut2 CATSTR <locuntilout2_>,@CatStr(%TotalRept)
		LastUntilOutLabel TEXTEQU UntilOut2
	ELSEIFIDN UntilOut3,<> 
		UntilOut3 CATSTR <locuntilout3_>,@CatStr(%TotalRept)
		LastUntilOutLabel TEXTEQU UntilOut3
	ELSEIFIDN UntilOut4,<> 
		UntilOut4 CATSTR <locuntilout4_>,@CatStr(%TotalRept)
		LastUntilOutLabel TEXTEQU UntilOut4
	ELSEIFIDN UntilOut5,<> 
		UntilOut5 CATSTR <locuntilout5_>,@CatStr(%TotalRept)
		LastUntilOutLabel TEXTEQU UntilOut5
	ELSEIFIDN UntilOut6,<> 
		UntilOut6 CATSTR <locuntilout6_>,@CatStr(%TotalRept)
		LastUntilOutLabel TEXTEQU UntilOut6
	ELSEIFIDN UntilOut7,<> 
		UntilOut7 CATSTR <locuntilout7_>,@CatStr(%TotalRept)
		LastUntilOutLabel TEXTEQU UntilOut7
	ELSEIFIDN UntilOut8,<> 
		UntilOut8 CATSTR <locuntilout8_>,@CatStr(%TotalRept)
		LastUntilOutLabel TEXTEQU UntilOut8
	ELSEIFIDN UntilOut9,<> 
		UntilOut9 CATSTR <locuntilout9_>,@CatStr(%TotalRept)
		LastUntilOutLabel TEXTEQU UntilOut9
	ELSEIFIDN UntilOut10,<>
		UntilOut10 CATSTR <locuntilout10_>,@CatStr(%TotalRept)
		LastUntilOutLabel TEXTEQU UntilOut10
	ELSEIFIDN UntilOut11,<> 
		UntilOut11 CATSTR <locuntilout11_>,@CatStr(%TotalRept)
		LastUntilOutLabel TEXTEQU UntilOut11
	ELSEIFIDN UntilOut12,<> 
		UntilOut12 CATSTR <locuntilout12_>,@CatStr(%TotalRept)
		LastUntilOutLabel TEXTEQU UntilOut12
	ELSEIFIDN UntilOut13,<> 
		UntilOut13 CATSTR <locuntilout13_>,@CatStr(%TotalRept)
		LastUntilOutLabel TEXTEQU UntilOut13
	ELSEIFIDN UntilOut14,<> 
		UntilOut14 CATSTR <locuntilout14_>,@CatStr(%TotalRept)
		LastUntilOutLabel TEXTEQU UntilOut14
	ELSEIFIDN UntilOut15,<> 
		UntilOut15 CATSTR <locuntilout15_>,@CatStr(%TotalRept)
		LastUntilOutLabel TEXTEQU UntilOut15
	ELSEIFIDN UntilOut16,<> 
		UntilOut16 CATSTR <locuntilout16_>,@CatStr(%TotalRept)
		LastUntilOutLabel TEXTEQU UntilOut16
	ELSEIFIDN UntilOut17,<> 
		UntilOut17 CATSTR <locuntilout17_>,@CatStr(%TotalRept)
		LastUntilOutLabel TEXTEQU UntilOut17
	ELSEIFIDN UntilOut18,<> 
		UntilOut18 CATSTR <locuntilout18_>,@CatStr(%TotalRept)
		LastUntilOutLabel TEXTEQU UntilOut18
	ELSEIFIDN UntilOut19,<> 
		UntilOut19 CATSTR <locuntilout19_>,@CatStr(%TotalRept)
		LastUntilOutLabel TEXTEQU UntilOut19
	ELSE
		.err .ifs error
	ENDIF
ENDM
GetUntilOutLabel MACRO
	IFDIF UntilOut19,<>
		LastUntilOutLabel TEXTEQU UntilOut19
	ELSEIFDIF UntilOut18,<>
		LastUntilOutLabel TEXTEQU UntilOut18
	ELSEIFDIF UntilOut17,<>
		LastUntilOutLabel TEXTEQU UntilOut17
	ELSEIFDIF UntilOut16,<>
		LastUntilOutLabel TEXTEQU UntilOut16
	ELSEIFDIF UntilOut15,<>
		LastUntilOutLabel TEXTEQU UntilOut15
	ELSEIFDIF UntilOut14,<>
		LastUntilOutLabel TEXTEQU UntilOut14
	ELSEIFDIF UntilOut13,<>
		LastUntilOutLabel TEXTEQU UntilOut13	
	ELSEIFDIF UntilOut12,<>
		LastUntilOutLabel TEXTEQU UntilOut12
	ELSEIFDIF UntilOut11,<>
		LastUntilOutLabel TEXTEQU UntilOut11	
	ELSEIFDIF UntilOut10,<>
		LastUntilOutLabel TEXTEQU UntilOut10
	ELSEIFDIF UntilOut9,<>
		LastUntilOutLabel TEXTEQU UntilOut9
	ELSEIFDIF UntilOut8,<>
		LastUntilOutLabel TEXTEQU UntilOut8
	ELSEIFDIF UntilOut7,<>
		LastUntilOutLabel TEXTEQU UntilOut7
	ELSEIFDIF UntilOut6,<>
		LastUntilOutLabel TEXTEQU UntilOut6
	ELSEIFDIF UntilOut5,<>
		LastUntilOutLabel TEXTEQU UntilOut5
	ELSEIFDIF UntilOut4,<>
		LastUntilOutLabel TEXTEQU UntilOut4
	ELSEIFDIF UntilOut3,<>
		LastUntilOutLabel TEXTEQU UntilOut3	
	ELSEIFDIF UntilOut2,<>
		LastUntilOutLabel TEXTEQU UntilOut2
	ELSEIFDIF UntilOut1,<>
		LastUntilOutLabel TEXTEQU UntilOut1	
	ELSEIFDIF UntilOut0,<>
		LastUntilOutLabel TEXTEQU UntilOut0
	ELSE
		LastUntilOutLabel TEXTEQU <>
	ENDIF		
ENDM
DelUntilOutLabel MACRO
	IFDIF UntilOut19,<>
		UntilOut19 TEXTEQU <>
	ELSEIFDIF UntilOut18,<>
		UntilOut18 TEXTEQU <>
	ELSEIFDIF UntilOut17,<>
		UntilOut17 TEXTEQU <>
	ELSEIFDIF UntilOut16,<>
		UntilOut16 TEXTEQU <>
	ELSEIFDIF UntilOut15,<>
		UntilOut15 TEXTEQU <>
	ELSEIFDIF UntilOut14,<>
		UntilOut14 TEXTEQU <>
	ELSEIFDIF UntilOut13,<>
		UntilOut13 TEXTEQU <>	
	ELSEIFDIF UntilOut12,<>
		UntilOut12 TEXTEQU <>
	ELSEIFDIF UntilOut11,<>
		UntilOut11 TEXTEQU <>	
	ELSEIFDIF UntilOut10,<>
		UntilOut10 TEXTEQU <>
	ELSEIFDIF UntilOut9,<>
		UntilOut9 TEXTEQU <>
	ELSEIFDIF UntilOut8,<>
		UntilOut8 TEXTEQU <>
	ELSEIFDIF UntilOut7,<>
		UntilOut7 TEXTEQU <>
	ELSEIFDIF UntilOut6,<>
		UntilOut6 TEXTEQU <>
	ELSEIFDIF UntilOut5,<>
		UntilOut5 TEXTEQU <>
	ELSEIFDIF UntilOut4,<>
		UntilOut4 TEXTEQU <>
	ELSEIFDIF UntilOut3,<>
		UntilOut3 TEXTEQU <>	
	ELSEIFDIF UntilOut2,<>
		UntilOut2 TEXTEQU <>
	ELSEIFDIF UntilOut1,<>
		UntilOut1 TEXTEQU <>	
	ELSEIFDIF UntilOut0,<>
		UntilOut0 TEXTEQU <>
	ENDIF
ENDM
OutLevel0 TEXTEQU <>
OutLevel1 TEXTEQU <>
OutLevel2 TEXTEQU <>
OutLevel3 TEXTEQU <>
OutLevel4 TEXTEQU <>
OutLevel5 TEXTEQU <>
OutLevel6 TEXTEQU <>
OutLevel7 TEXTEQU <>
OutLevel8 TEXTEQU <>
OutLevel9 TEXTEQU <>
OutLevel10 TEXTEQU <>
OutLevel11 TEXTEQU <>
OutLevel12 TEXTEQU <>
OutLevel13 TEXTEQU <>
OutLevel14 TEXTEQU <>
OutLevel15 TEXTEQU <>
OutLevel16 TEXTEQU <>
OutLevel17 TEXTEQU <>
OutLevel18 TEXTEQU <>
OutLevel19 TEXTEQU <>
LastOutLabel TEXTEQU <>
SaveOutLabel MACRO
	IFIDN OutLevel0,<>
		OutLevel0 CATSTR <locout0_>,@CatStr(%TotalIfs)
		LastOutLabel TEXTEQU OutLevel0
	ELSEIFIDN OutLevel1,<> 
		OutLevel1 CATSTR <locout1_>,@CatStr(%TotalIfs)
		LastOutLabel TEXTEQU OutLevel1
	ELSEIFIDN OutLevel2,<> 
		OutLevel2 CATSTR <locout2_>,@CatStr(%TotalIfs)
		LastOutLabel TEXTEQU OutLevel2
	ELSEIFIDN OutLevel3,<> 
		OutLevel3 CATSTR <locout3_>,@CatStr(%TotalIfs)
		LastOutLabel TEXTEQU OutLevel3
	ELSEIFIDN OutLevel4,<> 
		OutLevel4 CATSTR <locout4_>,@CatStr(%TotalIfs)
		LastOutLabel TEXTEQU OutLevel4
	ELSEIFIDN OutLevel5,<> 
		OutLevel5 CATSTR <locout5_>,@CatStr(%TotalIfs)
		LastOutLabel TEXTEQU OutLevel5
	ELSEIFIDN OutLevel6,<> 
		OutLevel6 CATSTR <locout6_>,@CatStr(%TotalIfs)
		LastOutLabel TEXTEQU OutLevel6
	ELSEIFIDN OutLevel7,<> 
		OutLevel7 CATSTR <locout7_>,@CatStr(%TotalIfs)
		LastOutLabel TEXTEQU OutLevel7
	ELSEIFIDN OutLevel8,<> 
		OutLevel8 CATSTR <locout8_>,@CatStr(%TotalIfs)
		LastOutLabel TEXTEQU OutLevel8
	ELSEIFIDN OutLevel9,<> 
		OutLevel9 CATSTR <locout9_>,@CatStr(%TotalIfs)
		LastOutLabel TEXTEQU OutLevel9
	ELSEIFIDN OutLevel10,<>
		OutLevel10 CATSTR <locout10_>,@CatStr(%TotalIfs)
		LastOutLabel TEXTEQU OutLevel10
	ELSEIFIDN OutLevel11,<> 
		OutLevel11 CATSTR <locout11_>,@CatStr(%TotalIfs)
		LastOutLabel TEXTEQU OutLevel11
	ELSEIFIDN OutLevel12,<> 
		OutLevel12 CATSTR <locout12_>,@CatStr(%TotalIfs)
		LastOutLabel TEXTEQU OutLevel12
	ELSEIFIDN OutLevel13,<> 
		OutLevel13 CATSTR <locout13_>,@CatStr(%TotalIfs)
		LastOutLabel TEXTEQU OutLevel13
	ELSEIFIDN OutLevel14,<> 
		OutLevel14 CATSTR <locout14_>,@CatStr(%TotalIfs)
		LastOutLabel TEXTEQU OutLevel14
	ELSEIFIDN OutLevel15,<> 
		OutLevel15 CATSTR <locout15_>,@CatStr(%TotalIfs)
		LastOutLabel TEXTEQU OutLevel15
	ELSEIFIDN OutLevel16,<> 
		OutLevel16 CATSTR <locout16_>,@CatStr(%TotalIfs)
		LastOutLabel TEXTEQU OutLevel16
	ELSEIFIDN OutLevel17,<> 
		OutLevel17 CATSTR <locout17_>,@CatStr(%TotalIfs)
		LastOutLabel TEXTEQU OutLevel17
	ELSEIFIDN OutLevel18,<> 
		OutLevel18 CATSTR <locout18_>,@CatStr(%TotalIfs)
		LastOutLabel TEXTEQU OutLevel18
	ELSEIFIDN OutLevel19,<> 
		OutLevel19 CATSTR <locout19_>,@CatStr(%TotalIfs)
		LastOutLabel TEXTEQU OutLevel19
	ELSE
		.err .ifs error
	ENDIF
ENDM
GetOutLabel MACRO
	IFDIF OutLevel19,<>
		LastOutLabel TEXTEQU OutLevel19
	ELSEIFDIF OutLevel18,<>
		LastOutLabel TEXTEQU OutLevel18
	ELSEIFDIF OutLevel17,<>
		LastOutLabel TEXTEQU OutLevel17
	ELSEIFDIF OutLevel16,<>
		LastOutLabel TEXTEQU OutLevel16
	ELSEIFDIF OutLevel15,<>
		LastOutLabel TEXTEQU OutLevel15
	ELSEIFDIF OutLevel14,<>
		LastOutLabel TEXTEQU OutLevel14
	ELSEIFDIF OutLevel13,<>
		LastOutLabel TEXTEQU OutLevel13	
	ELSEIFDIF OutLevel12,<>
		LastOutLabel TEXTEQU OutLevel12
	ELSEIFDIF OutLevel11,<>
		LastOutLabel TEXTEQU OutLevel11	
	ELSEIFDIF OutLevel10,<>
		LastOutLabel TEXTEQU OutLevel10
	ELSEIFDIF OutLevel9,<>
		LastOutLabel TEXTEQU OutLevel9
	ELSEIFDIF OutLevel8,<>
		LastOutLabel TEXTEQU OutLevel8
	ELSEIFDIF OutLevel7,<>
		LastOutLabel TEXTEQU OutLevel7
	ELSEIFDIF OutLevel6,<>
		LastOutLabel TEXTEQU OutLevel6
	ELSEIFDIF OutLevel5,<>
		LastOutLabel TEXTEQU OutLevel5
	ELSEIFDIF OutLevel4,<>
		LastOutLabel TEXTEQU OutLevel4
	ELSEIFDIF OutLevel3,<>
		LastOutLabel TEXTEQU OutLevel3	
	ELSEIFDIF OutLevel2,<>
		LastOutLabel TEXTEQU OutLevel2
	ELSEIFDIF OutLevel1,<>
		LastOutLabel TEXTEQU OutLevel1	
	ELSEIFDIF OutLevel0,<>
		LastOutLabel TEXTEQU OutLevel0
	ELSE
		LastOutLabel TEXTEQU <>
	ENDIF		
ENDM
DelOutLabel MACRO
	IFDIF OutLevel19,<>
		OutLevel19 TEXTEQU <>
	ELSEIFDIF OutLevel18,<>
		OutLevel18 TEXTEQU <>
	ELSEIFDIF OutLevel17,<>
		OutLevel17 TEXTEQU <>
	ELSEIFDIF OutLevel16,<>
		OutLevel16 TEXTEQU <>
	ELSEIFDIF OutLevel15,<>
		OutLevel15 TEXTEQU <>
	ELSEIFDIF OutLevel14,<>
		OutLevel14 TEXTEQU <>
	ELSEIFDIF OutLevel13,<>
		OutLevel13 TEXTEQU <>	
	ELSEIFDIF OutLevel12,<>
		OutLevel12 TEXTEQU <>
	ELSEIFDIF OutLevel11,<>
		OutLevel11 TEXTEQU <>	
	ELSEIFDIF OutLevel10,<>
		OutLevel10 TEXTEQU <>
	ELSEIFDIF OutLevel9,<>
		OutLevel9 TEXTEQU <>
	ELSEIFDIF OutLevel8,<>
		OutLevel8 TEXTEQU <>
	ELSEIFDIF OutLevel7,<>
		OutLevel7 TEXTEQU <>
	ELSEIFDIF OutLevel6,<>
		OutLevel6 TEXTEQU <>
	ELSEIFDIF OutLevel5,<>
		OutLevel5 TEXTEQU <>
	ELSEIFDIF OutLevel4,<>
		OutLevel4 TEXTEQU <>
	ELSEIFDIF OutLevel3,<>
		OutLevel3 TEXTEQU <>	
	ELSEIFDIF OutLevel2,<>
		OutLevel2 TEXTEQU <>
	ELSEIFDIF OutLevel1,<>
		OutLevel1 TEXTEQU <>	
	ELSEIFDIF OutLevel0,<>
		OutLevel0 TEXTEQU <>
	ENDIF
ENDM
IfLevel0 TEXTEQU <>
IfLevel1 TEXTEQU <>
IfLevel2 TEXTEQU <>
IfLevel3 TEXTEQU <>
IfLevel4 TEXTEQU <>
IfLevel5 TEXTEQU <>
IfLevel6 TEXTEQU <>
IfLevel7 TEXTEQU <>
IfLevel8 TEXTEQU <>
IfLevel9 TEXTEQU <>
IfLevel10 TEXTEQU <>
IfLevel11 TEXTEQU <>
IfLevel12 TEXTEQU <>
IfLevel13 TEXTEQU <>
IfLevel14 TEXTEQU <>
IfLevel15 TEXTEQU <>
IfLevel16 TEXTEQU <>
IfLevel17 TEXTEQU <>
IfLevel18 TEXTEQU <>
IfLevel19 TEXTEQU <>
LastDefLabel TEXTEQU <>
SaveCurrentLabel MACRO
	IFIDN IfLevel0,<>
		IfLevel0 CATSTR <locif0_>,@CatStr(%TotalIfs)
		LastDefLabel TEXTEQU IfLevel0
	ELSEIFIDN IfLevel1,<> 
		IfLevel1 CATSTR <locif1_>,@CatStr(%TotalIfs)
		LastDefLabel TEXTEQU IfLevel1
	ELSEIFIDN IfLevel2,<> 
		IfLevel2 CATSTR <locif2_>,@CatStr(%TotalIfs)
		LastDefLabel TEXTEQU IfLevel2
	ELSEIFIDN IfLevel3,<> 
		IfLevel3 CATSTR <locif3_>,@CatStr(%TotalIfs)
		LastDefLabel TEXTEQU IfLevel3
	ELSEIFIDN IfLevel4,<> 
		IfLevel4 CATSTR <locif4_>,@CatStr(%TotalIfs)
		LastDefLabel TEXTEQU IfLevel4
	ELSEIFIDN IfLevel5,<> 
		IfLevel5 CATSTR <locif5_>,@CatStr(%TotalIfs)
		LastDefLabel TEXTEQU IfLevel5
	ELSEIFIDN IfLevel6,<> 
		IfLevel6 CATSTR <locif6_>,@CatStr(%TotalIfs)
		LastDefLabel TEXTEQU IfLevel6
	ELSEIFIDN IfLevel7,<> 
		IfLevel7 CATSTR <locif7_>,@CatStr(%TotalIfs)
		LastDefLabel TEXTEQU IfLevel7
	ELSEIFIDN IfLevel8,<> 
		IfLevel8 CATSTR <locif8_>,@CatStr(%TotalIfs)
		LastDefLabel TEXTEQU IfLevel8
	ELSEIFIDN IfLevel9,<> 
		IfLevel9 CATSTR <locif9_>,@CatStr(%TotalIfs)
		LastDefLabel TEXTEQU IfLevel9
	ELSEIFIDN IfLevel10,<>
		IfLevel10 CATSTR <locif10_>,@CatStr(%TotalIfs)
		LastDefLabel TEXTEQU IfLevel10
	ELSEIFIDN IfLevel11,<> 
		IfLevel11 CATSTR <locif11_>,@CatStr(%TotalIfs)
		LastDefLabel TEXTEQU IfLevel11
	ELSEIFIDN IfLevel12,<> 
		IfLevel12 CATSTR <locif12_>,@CatStr(%TotalIfs)
		LastDefLabel TEXTEQU IfLevel12
	ELSEIFIDN IfLevel13,<> 
		IfLevel13 CATSTR <locif13_>,@CatStr(%TotalIfs)
		LastDefLabel TEXTEQU IfLevel13
	ELSEIFIDN IfLevel14,<> 
		IfLevel14 CATSTR <locif14_>,@CatStr(%TotalIfs)
		LastDefLabel TEXTEQU IfLevel14
	ELSEIFIDN IfLevel15,<> 
		IfLevel15 CATSTR <locif15_>,@CatStr(%TotalIfs)
		LastDefLabel TEXTEQU IfLevel15
	ELSEIFIDN IfLevel16,<> 
		IfLevel16 CATSTR <locif16_>,@CatStr(%TotalIfs)
		LastDefLabel TEXTEQU IfLevel16
	ELSEIFIDN IfLevel17,<> 
		IfLevel17 CATSTR <locif17_>,@CatStr(%TotalIfs)
		LastDefLabel TEXTEQU IfLevel17
	ELSEIFIDN IfLevel18,<> 
		IfLevel18 CATSTR <locif18_>,@CatStr(%TotalIfs)
		LastDefLabel TEXTEQU IfLevel18
	ELSEIFIDN IfLevel19,<> 
		IfLevel19 CATSTR <locif19_>,@CatStr(%TotalIfs)
		LastDefLabel TEXTEQU IfLevel19
	ELSE
		.err .ifs error
	ENDIF
	TotalIfs = TotalIfs+1
ENDM
GetCurrentLabel MACRO
	IFDIF IfLevel19,<>
		LastDefLabel TEXTEQU IfLevel19
	ELSEIFDIF IfLevel18,<>
		LastDefLabel TEXTEQU IfLevel18
	ELSEIFDIF IfLevel17,<>
		LastDefLabel TEXTEQU IfLevel17
	ELSEIFDIF IfLevel16,<>
		LastDefLabel TEXTEQU IfLevel16
	ELSEIFDIF IfLevel15,<>
		LastDefLabel TEXTEQU IfLevel15
	ELSEIFDIF IfLevel14,<>
		LastDefLabel TEXTEQU IfLevel14
	ELSEIFDIF IfLevel13,<>
		LastDefLabel TEXTEQU IfLevel13	
	ELSEIFDIF IfLevel12,<>
		LastDefLabel TEXTEQU IfLevel12
	ELSEIFDIF IfLevel11,<>
		LastDefLabel TEXTEQU IfLevel11	
	ELSEIFDIF IfLevel10,<>
		LastDefLabel TEXTEQU IfLevel10
	ELSEIFDIF IfLevel9,<>
		LastDefLabel TEXTEQU IfLevel9
	ELSEIFDIF IfLevel8,<>
		LastDefLabel TEXTEQU IfLevel8
	ELSEIFDIF IfLevel7,<>
		LastDefLabel TEXTEQU IfLevel7
	ELSEIFDIF IfLevel6,<>
		LastDefLabel TEXTEQU IfLevel6
	ELSEIFDIF IfLevel5,<>
		LastDefLabel TEXTEQU IfLevel5
	ELSEIFDIF IfLevel4,<>
		LastDefLabel TEXTEQU IfLevel4
	ELSEIFDIF IfLevel3,<>
		LastDefLabel TEXTEQU IfLevel3	
	ELSEIFDIF IfLevel2,<>
		LastDefLabel TEXTEQU IfLevel2
	ELSEIFDIF IfLevel1,<>
		LastDefLabel TEXTEQU IfLevel1	
	ELSEIFDIF IfLevel0,<>
		LastDefLabel TEXTEQU IfLevel0
	ELSE
		LastDefLabel TEXTEQU <>
	ENDIF		
ENDM
DelCurrentLabel MACRO
	IFDIF IfLevel19,<>
		IfLevel19 TEXTEQU <>
	ELSEIFDIF IfLevel18,<>
		IfLevel18 TEXTEQU <>
	ELSEIFDIF IfLevel17,<>
		IfLevel17 TEXTEQU <>
	ELSEIFDIF IfLevel16,<>
		IfLevel16 TEXTEQU <>
	ELSEIFDIF IfLevel15,<>
		IfLevel15 TEXTEQU <>
	ELSEIFDIF IfLevel14,<>
		IfLevel14 TEXTEQU <>
	ELSEIFDIF IfLevel13,<>
		IfLevel13 TEXTEQU <>	
	ELSEIFDIF IfLevel12,<>
		IfLevel12 TEXTEQU <>
	ELSEIFDIF IfLevel11,<>
		IfLevel11 TEXTEQU <>	
	ELSEIFDIF IfLevel10,<>
		IfLevel10 TEXTEQU <>
	ELSEIFDIF IfLevel9,<>
		IfLevel9 TEXTEQU <>
	ELSEIFDIF IfLevel8,<>
		IfLevel8 TEXTEQU <>
	ELSEIFDIF IfLevel7,<>
		IfLevel7 TEXTEQU <>
	ELSEIFDIF IfLevel6,<>
		IfLevel6 TEXTEQU <>
	ELSEIFDIF IfLevel5,<>
		IfLevel5 TEXTEQU <>
	ELSEIFDIF IfLevel4,<>
		IfLevel4 TEXTEQU <>
	ELSEIFDIF IfLevel3,<>
		IfLevel3 TEXTEQU <>	
	ELSEIFDIF IfLevel2,<>
		IfLevel2 TEXTEQU <>
	ELSEIFDIF IfLevel1,<>
		IfLevel1 TEXTEQU <>	
	ELSEIFDIF IfLevel0,<>
		IfLevel0 TEXTEQU <>
	ENDIF
ENDM
.if MACRO args:VARARG
	SaveOutLabel
	SaveCurrentLabel
	PolyConditionsHandler LastDefLabel,FALSE,args
ENDM
.elseif MACRO args:VARARG
	GetOutLabel
	LastOutLabel CATSTR <jmp >,LastOutLabel
	LastOutLabel
	
	GetCurrentLabel
	LastDefLabel CATSTR LastDefLabel,<:>
	LastDefLabel
	DelCurrentLabel
	SaveCurrentLabel
	
	PolyConditionsHandler LastDefLabel,FALSE,args	
ENDM
.else MACRO
	GetOutLabel
	LastOutLabel CATSTR <jmp >,LastOutLabel
	LastOutLabel
	
	GetCurrentLabel
	LastDefLabel CATSTR LastDefLabel,<:>
	LastDefLabel
	DelCurrentLabel
	SaveCurrentLabel
ENDM
.endif MACRO
	GetCurrentLabel
	LastDefLabel CATSTR LastDefLabel,<:>
	LastDefLabel
	DelCurrentLabel
	GetOutLabel
	LastOutLabel CATSTR LastOutLabel,<:>
	LastOutLabel
	DelOutLabel
ENDM
.repeat MACRO
	SaveUntilOutLabel
	SaveUntilLabel
	LastUntilLabel CATSTR LastUntilLabel,<:>
	LastUntilLabel
	SaveUntilCondsLabel
ENDM
.break MACRO args:VARARG
	GetUntilOutLabel
	IF @SizeStr(<args>) NE 0
		PolyConditionsHandler LastUntilOutLabel,TRUE,@SubStr(<args>,5,@SizeStr(<args>)-4)
		GOTO EndBreak		
	ELSE
		LastUntilOutLabel CATSTR <jmp >,LastUntilOutLabel
		LastUntilOutLabel
	ENDIF
:EndBreak
ENDM
.continue MACRO args:VARARG
	GetUntilCondsLabel
	IF @SizeStr(<args>) NE 0
		PolyConditionsHandler LastUntilConds,TRUE,@SubStr(<args>,5,@SizeStr(<args>)-4)		
	ELSE
		LastUntilConds CATSTR <jmp >,LastUntilConds
		LastUntilConds
	ENDIF
ENDM
.until MACRO args:VARARG
	GetUntilCondsLabel
	LastUntilConds CATSTR LastUntilConds,<:>
	LastUntilConds
	DelUntilCondsLabel
	
	GetUntilLabel
	IF @SizeStr(<args>) NE 0
		PolyConditionsHandler LastUntilLabel,FALSE,args
	ELSE
		LastUntilLabel CATSTR <jmp >,LastUntilLabel
		LastUntilLabel
	ENDIF
	DelUntilLabel
	GetUntilOutLabel
	LastUntilOutLabel CATSTR LastUntilOutLabel,<:>
	LastUntilOutLabel
	DelUntilOutLabel	
ENDM
.untilcxz MACRO
	GetUntilCondsLabel
	LastUntilConds CATSTR LastUntilConds,<:>
	LastUntilConds
	DelUntilCondsLabel
	
	GetUntilLabel
	LastUntilLabel CATSTR <loop >,LastUntilLabel
	LastUntilLabel
	DelUntilLabel
	
	GetUntilOutLabel
	LastUntilOutLabel CATSTR LastUntilOutLabel,<:>
	LastUntilOutLabel
	DelUntilOutLabel
ENDM
.untilcxze MACRO
	GetUntilCondsLabel
	LastUntilConds CATSTR LastUntilConds,<:>
	LastUntilConds
	DelUntilCondsLabel
	
	GetUntilLabel
	LastUntilLabel CATSTR <loope >,LastUntilLabel
	LastUntilLabel
	DelUntilLabel
	
	GetUntilOutLabel
	LastUntilOutLabel CATSTR LastUntilOutLabel,<:>
	LastUntilOutLabel
	DelUntilOutLabel
ENDM
.untilcxzne MACRO
	GetUntilCondsLabel
	LastUntilConds CATSTR LastUntilConds,<:>
	LastUntilConds
	DelUntilCondsLabel
	
	GetUntilLabel
	LastUntilLabel CATSTR <loopne >,LastUntilLabel
	LastUntilLabel
	DelUntilLabel
	
	GetUntilOutLabel
	LastUntilOutLabel CATSTR LastUntilOutLabel,<:>
	LastUntilOutLabel
	DelUntilOutLabel
ENDM
.while MACRO args:VARARG
	SaveUntilCondsLabel
%	IFDIF <args>,<TRUE>
		LastUntilConds CATSTR <jmp >,LastUntilConds
		LastUntilConds
	ENDIF
	SaveWhileConds args
	SaveUntilOutLabel
	SaveUntilLabel
	LastUntilLabel CATSTR LastUntilLabel,<:>
	LastUntilLabel
ENDM
.endw MACRO
	GetUntilCondsLabel
	LastUntilConds CATSTR LastUntilConds,<:>
	LastUntilConds
	DelUntilCondsLabel
	
	GetWhileConds
	IF @SizeStr(LastWhileConds) NE 0
		GetUntilLabel
	%	PolyConditionsHandler LastUntilLabel,TRUE,LastWhileConds
	ENDIF
	DelUntilLabel
	DelWhileConds
	GetUntilOutLabel
	LastUntilOutLabel CATSTR LastUntilOutLabel,<:>
	LastUntilOutLabel
	DelUntilOutLabel	
ENDM	
IS_ALNUM MACRO char
CharPosition INSTR 1,<0123456789abcdefghijklmnopqrstvuwxyzABCDEFGHIJKLMNOPQRSTVUWXYZ>,<char>
	exitm <@CatStr(%CharPosition)>
ENDM
IS_CHAR_FOR_NAMES MACRO char
CharPosition INSTR 1,<0123456789abcdefghijklmnopqrstvuwxyzABCDEFGHIJKLMNOPQRSTVUWXYZ_.[]-+*/ >,<char>
	exitm <@CatStr(%CharPosition)>
ENDM
IS_INT_REG MACRO val
RegPosition INSTR 1,< rsi al bl cl dl ah bh ch dh sil dil bpl spl r8b r9b r10b r11b r12b r13b r14b r15b eax ebx ecx edx esi edi ebp esp r14d r15d >,<val>
	IF RegPosition EQ 0
		RegPosition INSTR 1,< rax rbx rdx rcx rsi rdi rbp rsp r8w r9w r10w r11w r12w r13w r14w r15w r8d r9d r10d r11d r12d r13d r8 r9 r10 r11 r12 r13 r14 r15 >,<val>
	ENDIF
	exitm <@CatStr(%RegPosition)>
ENDM
ConditionOneHandler MACRO LabelName,IsTrueCondition,ConditionOne:VARARG
;;	%echo ConditionOne
	IFIDN @SubStr(<ConditionOne>,1,1),<~>
		IFIDN @SubStr(<ConditionOne>,2,1),<(>
			IFIDN <IsTrueCondition>,<FALSE>
				ConditionOneHandler LabelName,TRUE,@SubStr(<ConditionOne>,3,@SizeStr(<ConditionOne>)-3)
			ELSE
				ConditionOneHandler LabelName,FALSE,@SubStr(<ConditionOne>,3,@SizeStr(<ConditionOne>)-3)
			ENDIF
		ELSE
			IFIDN <IsTrueCondition>,<FALSE>
				ConditionOneHandler LabelName,TRUE,@SubStr(<ConditionOne>,2,@SizeStr(<ConditionOne>)-1)
			ELSE
				ConditionOneHandler LabelName,FALSE,@SubStr(<ConditionOne>,2,@SizeStr(<ConditionOne>)-1)
			ENDIF
		ENDIF
	ELSE
	IFIDN <IsTrueCondition>,<FALSE>
		NegateChar TEXTEQU <n>
		TrueChar TEXTEQU <>
	ELSE
		NegateChar TEXTEQU <>
		TrueChar TEXTEQU <n>
	ENDIF
	CurrentNumChar =0
	OperatorPos = 0
	FORC char,<ConditionOne>
		CurrentNumChar = CurrentNumChar+1
		IF OperatorPos EQ 0
			IsNotOperatorChar = IS_CHAR_FOR_NAMES(<char>)
			IF IsNotOperatorChar EQ 0
				OperatorPos = CurrentNumChar
			ENDIF
		ENDIF
	ENDM
	IF OperatorPos NE 0
		SingleRunTimeOperator SUBSTR <ConditionOne>,OperatorPos,1
	ELSE
		SingleRunTimeOperator TEXTEQU <>
	ENDIF
	CmpCmd TEXTEQU <>
	IFIDN SingleRunTimeOperator,<?>
		IFIDN <ConditionOne>,<ZERO?|PARITY?>
			JCOND CATSTR <j>,NegateChar,<pe>,< &LabelName>
		ELSEIFIDN <ConditionOne>,<ZERO?|(SIGN?{}OVERFLOW?)>
			JCOND CATSTR <j>,NegateChar,<le>,< &LabelName>
		ELSEIFIDN <ConditionOne>,<SIGN?{}OVERFLOW?>
			JCOND CATSTR <j>,NegateChar,<l>,< &LabelName>
		ELSEIFIDN <ConditionOne>,<ZERO?&(SIGN?==OVERFLOW?)>
			JCOND CATSTR <j>,TrueChar,<g>,< &LabelName>
		ELSEIFIDN <ConditionOne>,<SIGN?==OVERFLOW?>
			JCOND CATSTR <j>,NegateChar,<ge>,< &LabelName>
		ELSEIFIDN <ConditionOne>,<CARRY?|ZERO?>
			JCOND CATSTR <j>,NegateChar,<be>,< &LabelName>
		ELSEIFIDN <ConditionOne>,<CARRY?&ZERO?>
			JCOND CATSTR <j>,NegateChar,<a>,< &LabelName>
		ELSEIFIDN <ConditionOne>,<SIGN?>
			JCOND CATSTR <j>,NegateChar,<s>,< &LabelName>
		ELSEIFIDN <ConditionOne>,<ZERO?>
			JCOND CATSTR <j>,NegateChar,<z>,< &LabelName>
		ELSEIFIDN <ConditionOne>,<OVERFLOW?>
			JCOND CATSTR <j>,NegateChar,<o>,< &LabelName>
		ELSEIFIDN <ConditionOne>,<PARITY?>
			JCOND CATSTR <j>,NegateChar,<p>,< &LabelName>
		ELSEIFIDN <ConditionOne>,<CARRY?>
			JCOND CATSTR <j>,NegateChar,<c>,< &LabelName>
		ELSE
			.err Bab Condition
		ENDIF
	ELSEIF OperatorPos NE 0
		RunTimeOperator SUBSTR <ConditionOne>,OperatorPos,2
		FirstArg SUBSTR <ConditionOne>,1,OperatorPos-1
		IF @SizeStr(<ConditionOne>) GE OperatorPos+2
			SecondArg SUBSTR <ConditionOne>,OperatorPos+2,@SizeStr(<ConditionOne>)-OperatorPos-1
		ENDIF
		JCOND TEXTEQU <>
		IFIDN RunTimeOperator,<==>		
			JCOND CATSTR <j>,NegateChar,<z>,< &LabelName>
		ELSEIFIDN RunTimeOperator,<{}>
			JCOND CATSTR <j>,TrueChar,<z>,< &LabelName>
		ELSEIFIDN RunTimeOperator,<}=>
			JCOND CATSTR <j>,NegateChar,<ae>,< &LabelName>
		ELSEIFIDN RunTimeOperator,<{=>
			JCOND CATSTR <j>,NegateChar,<be>,< &LabelName>
		ENDIF
		IFIDN JCOND,<>
			SecondArg SUBSTR <ConditionOne>,OperatorPos+1,@SizeStr(<ConditionOne>)-OperatorPos
			IFIDN SingleRunTimeOperator,<}>
				JCOND CATSTR <j>,NegateChar,<a>,< &LabelName> 
			ELSEIFIDN SingleRunTimeOperator,<{>
				JCOND CATSTR <j>,NegateChar,<b>,< &LabelName>
			ELSEIFIDN SingleRunTimeOperator,<|>
				CmpCmd TEXTEQU <or &FirstArg,&SecondArg>
				JCOND CATSTR <j>,TrueChar,<z>,< &LabelName>
			ELSEIFIDN SingleRunTimeOperator,<&>
				IFIDN SecondArg,<SIGN?>
					IF IS_INT_REG(%FirstArg) EQ 0
						CmpCmd TEXTEQU <cmp &FirstArg,0>
						
					ELSE
						CmpCmd TEXTEQU <or &FirstArg,&FirstArg>
					ENDIF
					JCOND CATSTR <j>,NegateChar,<s>,< &LabelName>
				ELSE
					CmpCmd TEXTEQU <test &FirstArg,&SecondArg>
					JCOND CATSTR <j>,TrueChar,<z>,< &LabelName>
				ENDIF
			ELSE
				.err Bad conditional operator	
			ENDIF
		ENDIF
		IFDIF SecondArg,<>
			IFIDN CmpCmd,<>
				CmpCmd TEXTEQU <cmp &FirstArg,&SecondArg>
			ENDIF
		ENDIF

	ELSE
		FirstArg TEXTEQU <ConditionOne>
		IF IS_INT_REG(%FirstArg) EQ 0
			CmpCmd TEXTEQU <cmp &FirstArg,0>
			JCOND CATSTR <j>,TrueChar,<z>,< &LabelName>
		ELSE
			IF @InStr(1,%FirstArg,<cx>) NE 0
			%	IFIDN <IsTrueCondition>,<FALSE>
					JCOND CATSTR <j>,FirstArg,<z>,< &LabelName>
					%JCOND
					GOTO EndCondOne
				ENDIF
			ENDIF
			CmpCmd TEXTEQU <test &FirstArg,&FirstArg>
			JCOND CATSTR <j>,TrueChar,<z>,< &LabelName>
		ENDIF
	ENDIF
;;	%echo CmpCmd
;;	%echo JCOND
	%CmpCmd
	%JCOND	
	ENDIF
:EndCondOne
ENDM
IsConditionOne MACRO CondString:VARARG
LOCAL Ands
FirstChar = 1
:StartIsConditionOne
	IsCondOne INSTR FirstChar,<CondString>,< && >
	IF IsCondOne EQ 0
		IsCondOne INSTR FirstChar,<CondString>,< || >
	ENDIF
	IF IsCondOne NE 0
		FirstChar = IsCondOne+4
		IFIDN @SubStr(<CondString>,IsCondOne-1,6),<' || '>
			GOTO StartIsConditionOne
		ENDIF
	ENDIF
	IF IsCondOne EQ 0
		IsCondOne = 1
	ELSE
		IsCondOne = 0
	ENDIF	
	EXITM <@CatStr(%IsCondOne)> 
ENDM
IntermedLabel = 0
PolyConditionsHandler MACRO LabelName,TrueConditions,ConditionsString:VARARG
LOCAL BeginCond,EndCond,LogOperator,locLabel,SetLabel,phCount,pLogOperator,IsTrueConditions,NegCond,locLabel2,lenCond,LogMain,EndLabel,EndLabel2,LastConds
%	IFIDN <ConditionsString>,<TRUE>
		IFDIF <TrueConditions>,<FALSE>
			EndLabel CATSTR <jmp >,<LabelName>
			EndLabel	
		ENDIF
		GOTO EndConditions
	ENDIF
	BeginCond = 1
	EndCond = 1
	SetLabel = 0
	NegCond = 0
	LastConds = 0
	IsTrueConditions TEXTEQU <TrueConditions>
%	IF IsConditionOne(<ConditionsString>) EQ 1
		IFIDN @SubStr(<ConditionsString>,BeginCond,1),<(>
		%	ConditionOneHandler LabelName,IsTrueConditions,@SubStr(<ConditionsString>,2,@SizeStr(<ConditionsString>)-2)
		ELSE
		%	ConditionOneHandler LabelName,IsTrueConditions,ConditionsString
		ENDIF
	ELSE
	%	EndLabel TEXTEQU <intermedloc_&@CatStr(%IntermedLabel)>
	%	EndLabel2 TEXTEQU <intermedloc_&@CatStr(%IntermedLabel):>	
		IntermedLabel = IntermedLabel+1
		LogMain TEXTEQU < || >
		IFIDN IsTrueConditions,<FALSE>
			LogMain TEXTEQU < && >
		ENDIF
		SetLabel = 0
		LogOperator = 0
	:NextCond	
		IFIDN @SubStr(<ConditionsString>,BeginCond,2),<~(>
		%	IFIDN <IsTrueConditions>,<FALSE>
				IsTrueConditions TEXTEQU <TRUE>
			ELSE
				IsTrueConditions TEXTEQU <FALSE>
			ENDIF
			BeginCond = BeginCond+1
			NegCond = 1
		ENDIF		
		IFIDN @SubStr(<ConditionsString>,BeginCond,1),<(>	;;    
			BeginCond = BeginCond+1
			phCount = 1
			EndCond = BeginCond
			lenCond = @SizeStr(<ConditionsString>)-BeginCond+2
		:NextChar
			IF phCount EQ 0
				GOTO phFound
			ENDIF
			lenCond = lenCond-1
			IF lenCond EQ 0
				GOTO EndConditions
			ENDIF
		%	IFIDN <@SubStr(<ConditionsString>,EndCond,1)>,<(>
				EndCond = EndCond+1
				phCount = phCount+1
				GOTO NextChar	
		%	ELSEIFIDN <@SubStr(<ConditionsString>,EndCond,1)>,<)>
				EndCond = EndCond+1
				phCount = phCount-1
				GOTO NextChar
			ELSE
				
				EndCond = EndCond+1
				GOTO NextChar
			ENDIF
		:phFound
			LogOperator = EndCond
			EndCond = EndCond-1
			;;
			IF NegCond EQ 1
			;;%	echo @SubStr(<ConditionsString>,BeginCond-2,(EndCond-BeginCond+3))
				IF IsConditionOne(@SubStr(<ConditionsString>,BeginCond-2,(EndCond-BeginCond+3))) EQ 1
				%	IFIDN <IsTrueConditions>,<FALSE>
						IsTrueConditions TEXTEQU <TRUE>
					ELSE
						IsTrueConditions TEXTEQU <FALSE>
					ENDIF
					BeginCond = BeginCond-2
					EndCond = EndCond+1
					NegCond = 0
				ENDIF
			ENDIF
			;;			
			GOTO phReady
		ELSE
			EndCond INSTR BeginCond,<ConditionsString>,< || >
			IF @InStr(BeginCond,<ConditionsString>,< && >) NE 0
				IF @InStr(BeginCond,<ConditionsString>,< || >) GT @InStr(BeginCond,<ConditionsString>,< && >)
					EndCond INSTR BeginCond,<ConditionsString>,< && >
				ELSEIF @InStr(BeginCond,<ConditionsString>,< || >) EQ 0
					EndCond INSTR BeginCond,<ConditionsString>,< && >
				ENDIF
			ENDIF
			LogOperator = EndCond
		ENDIF
		:phReady
		lenCond SIZESTR <ConditionsString>
		lenCond = lenCond-EndCond
		IF lenCond EQ 0
			IF SetLabel EQ 0
			%	PolyConditionsHandler LabelName,IsTrueConditions,@SubStr(<ConditionsString>,BeginCond,@SizeStr(<ConditionsString>)-BeginCond)
			;;	%echo EndLabel2
				EndLabel2
				GOTO EndConditions
			ELSE
			%	PolyConditionsHandler LabelName,IsTrueConditions,@SubStr(<ConditionsString>,BeginCond,@SizeStr(<ConditionsString>)-BeginCond)
			;;	%echo locLabel2
				locLabel2
			;;	%echo EndLabel2
				EndLabel2
				GOTO EndConditions

			ENDIF
		ENDIF
		IF SetLabel EQ 0
			IFIDN @SubStr(<ConditionsString>,LogOperator,4),< || >
			%	IFDIF <IsTrueConditions>,<FALSE>
					PolyConditionsHandler LabelName,TRUE,@SubStr(<ConditionsString>,BeginCond,EndCond-BeginCond)
				ELSE
					PolyConditionsHandler EndLabel,TRUE,@SubStr(<ConditionsString>,BeginCond,EndCond-BeginCond)
				ENDIF
			ELSE
				SetLabel = 1
			%	IFNDEF locLabel
				%	locLabel TEXTEQU <intermedloc_&@CatStr(%IntermedLabel)>
				%	locLabel2 TEXTEQU <intermedloc_&@CatStr(%IntermedLabel):>
				ELSE
					numic CATSTR %IntermedLabel
					locLabel TEXTEQU <intermedloc_&numic>
					locLabel2 CATSTR <intermedloc_>,numic,<:>
				ENDIF	
				IntermedLabel = IntermedLabel+1
				phCount = 0
				RemnConds2 SUBSTR <ConditionsString>,LogOperator+4,@SizeStr(<ConditionsString>)-LogOperator-3
				RemnConds TEXTEQU <>
			%	FORC char,<RemnConds2>
					IF phCount EQ 0
						IFIDN <char>,<(>
							phCount = 1
						ELSEIFIDN <char>,< >
							RemnConds CATSTR RemnConds,<++>
						ELSE
							RemnConds CATSTR RemnConds,<char>			
						ENDIF
					ELSE
						IFIDN  <char>,<(>
							phCount = phCount+1
						ELSEIFIDN <char>,<)>
							phCount = phCount-1
						ENDIF
					ENDIF
				ENDM
				LastConds = 1
				lenCond SIZESTR RemnConds
				IF lenCond NE 0
					IF @InStr(1,%RemnConds,<++||++>) NE 0
						LastConds = 0
					ELSE
						LastConds = 1
					ENDIF
				ENDIF	
			%	IFIDN <IsTrueConditions>,<FALSE>
					IF LastConds EQ 1
						IF NegCond EQ 1
							PolyConditionsHandler locLabel,TRUE,@SubStr(<ConditionsString>,BeginCond,EndCond-BeginCond)
						ELSE
							PolyConditionsHandler LabelName,FALSE,@SubStr(<ConditionsString>,BeginCond,EndCond-BeginCond)
						ENDIF
						GOTO forward
					ELSE
						PolyConditionsHandler locLabel,TRUE,@SubStr(<ConditionsString>,BeginCond,EndCond-BeginCond)
						GOTO forward
					ENDIF
				ELSE
					IF (LastConds EQ 1) AND (NegCond EQ 1)
						;;IF NegCond EQ 1
						PolyConditionsHandler LabelName,TRUE,@SubStr(<ConditionsString>,BeginCond,EndCond-BeginCond)
						GOTO forward
						;;ENDIF
					ENDIF
					PolyConditionsHandler locLabel,FALSE,@SubStr(<ConditionsString>,BeginCond,EndCond-BeginCond)
				ENDIF
			ENDIF
			GOTO forward
		ELSE
			IFIDN @SubStr(<ConditionsString>,LogOperator,4),< || >
			%	IFDIF <IsTrueConditions>,<FALSE>
					PolyConditionsHandler LabelName,TRUE,@SubStr(<ConditionsString>,BeginCond,EndCond-BeginCond)
				ELSE
					PolyConditionsHandler EndLabel,TRUE,@SubStr(<ConditionsString>,BeginCond,EndCond-BeginCond)
				ENDIF
				;;%echo locLabel2
				locLabel2
				SetLabel = 0
			ELSE
			%	IFIDN <IsTrueConditions>,<FALSE>
					IF LastConds EQ 1
						PolyConditionsHandler LabelName,FALSE,@SubStr(<ConditionsString>,BeginCond,EndCond-BeginCond)
						GOTO forward
					ELSE
						PolyConditionsHandler locLabel,TRUE,@SubStr(<ConditionsString>,BeginCond,EndCond-BeginCond)
						GOTO forward
					ENDIF
				ELSE
					PolyConditionsHandler locLabel,FALSE,@SubStr(<ConditionsString>,BeginCond,EndCond-BeginCond)
				ENDIF
			ENDIF
		ENDIF
		:forward
		IF NegCond EQ 1
		%	IFIDN <IsTrueConditions>,<FALSE>
				IsTrueConditions TEXTEQU <TRUE>
			ELSE
				IsTrueConditions TEXTEQU <FALSE>
			ENDIF
			NegCond = 0
		ENDIF		
		BeginCond = LogOperator+4
		IF SetLabel EQ 0
			IF IsConditionOne(@SubStr(<ConditionsString>,BeginCond,@SizeStr(<ConditionsString>)-BeginCond+1)) EQ 1
			%	PolyConditionsHandler LabelName,IsTrueConditions,@SubStr(<ConditionsString>,BeginCond,@SizeStr(<ConditionsString>)-BeginCond+1)
				;;%echo EndLabel2
				EndLabel2
				GOTO EndConditions
			ENDIF
			GOTO NextCond
		ELSE
		;;	%echo @SubStr(<ConditionsString>,BeginCond,@SizeStr(<ConditionsString>)-BeginCond+1)
			IF IsConditionOne(@SubStr(<ConditionsString>,BeginCond,@SizeStr(<ConditionsString>)-BeginCond+1)) EQ 1
			%	PolyConditionsHandler LabelName,IsTrueConditions,@SubStr(<ConditionsString>,BeginCond,@SizeStr(<ConditionsString>)-BeginCond+1)
				;%echo locLabel2
				locLabel2
				;%echo EndLabel2
				EndLabel2
				GOTO EndConditions
			ENDIF
			GOTO NextCond
		ENDIF
		GOTO NextCond
	ENDIF
:EndConditions
ENDM
pushm MACRO args:VARARG
TEX TEXTEQU <>
address TEXTEQU <>
FOR item,<args>
	IF @SizeStr(<item>) GE 6
		TEX SUBSTR <item>,1,4
		address SUBSTR <item>, 6, @SizeStr(<item>) - 5
		IFIDN TEX,<addr>
			lea rax,address
			push rax
		ELSEIFIDN TEX,<ADDR>
			lea rax,address
			push rax
		ELSEIFIDN TEX,<Addr>
			lea rax,address
			push rax
		ELSE
			push item
		ENDIF
	ELSE
		push item
	ENDIF
ENDM
ENDM
register MACRO reg,item
TEX TEXTEQU <>
address TEXTEQU <>
IFDIF <reg>,<item>
	IF @SizeStr(<item>) GE 6
		TEX SUBSTR <item>,1,4
		address SUBSTR <item>, 6, @SizeStr(<item>) - 5
		IFIDN TEX,<addr>
			lea reg,address
		ELSEIFIDN TEX,<ADDR>
			lea reg,address
		ELSEIFIDN TEX,<Addr>
			lea reg,address
		ELSE
			mov reg,item
		ENDIF
	ELSE
		mov reg,item
	ENDIF
ENDIF
ENDM
ToUpper MACRO String:VARARG
LOCAL UpperStr,LowNum
	UpperStr TEXTEQU <>
%	FORC char,<String>
		LowNum INSTR 1,<abcdefghijklmnopqrstuvwxyz>,<char>
		IF LowNum NE 0
			UpperStr CATSTR UpperStr,@SubStr(<ABCDEFGHIJKLMNOPQRSTUVWXYZ>,LowNum,1)
		ELSE
			UpperStr CATSTR UpperStr,<char>
		ENDIF
	ENDM
	EXITM <UpperStr>
ENDM
ToLower MACRO String:VARARG
LOCAL UpperStr,LowNum
	UpperStr TEXTEQU <>
%	FORC char,<String>
		LowNum INSTR 1,<ABCDEFGHIJKLMNOPQRSTUVWXYZ>,<char>
		IF LowNum NE 0
			UpperStr CATSTR UpperStr,@SubStr(<abcdefghijklmnopqrstuvwxyz>,LowNum,1)
		ELSE
			UpperStr CATSTR UpperStr,<char>
		ENDIF
	ENDM
	EXITM <UpperStr>
ENDM
JustLeaveFrame = 0
leavef MACRO
	JustLeaveFrame = 1
	ret
	JustLeaveFrame = 0
ENDM
rbpFrame=0
rspFrame=0
rbpFirstArgBias=0
DefaultInvokeArgs=7
rbpFramePrologue MACRO procname,flags,argbytes,localbytes,reglist,userparms:VARARG
LOCAL RegCnt,RegSize,MaxInvokeParms,allbytes
	RegCnt=0
	IFNB <reglist>
	    FOR reg,reglist
	    	RegCnt=RegCnt+1
	    ENDM
    ENDIF
;;    %echo procname
;;    %echo @CatStr(%argbytes)
    MaxInvokeParms=DefaultInvokeArgs
    IFNB <userparms>
    	MaxInvokeParms=@CatStr(%userparms)
    ENDIF
    allbytes=localbytes+8*(RegCnt+MaxInvokeParms)
    IF (allbytes AND 7) NE 0
    	allbytes=allbytes-(allbytes AND 7)+8
    ENDIF
    IF (allbytes AND 8) NE 0
    	allbytes=allbytes+8
    ENDIF
    IF (localbytes+argbytes-8) EQ 0
		IFDIF reglist,<>
			FOR reg,reglist
				push reg
			ENDM
			allbytes=8*(RegCnt+MaxInvokeParms)
			IF (allbytes AND 8) EQ 0
				allbytes=(8*MaxInvokeParms)+8
			ELSE
				allbytes=8*MaxInvokeParms
			ENDIF
			IF allbytes LE 4096
				sub rsp,allbytes
			ELSE
				IFDEF __chkstk
					mov rax,allbytes
					call __chkstk
					sub rsp,rax
				ELSE
					sub rsp,allbytes
				ENDIF
			ENDIF
		ENDIF
		rbpFrame=0
		rspFrame=1
	ELSEIF allbytes LE 4096
		rbpFrame=1
		rspFrame=0
		enter allbytes,0
		rbpFirstArgBias=allbytes
		allbytes=allbytes-8*MaxInvokeParms
		IFNB <reglist>
			FOR reg,reglist
				mov [rbp-allbytes],reg
				allbytes=allbytes-8
			ENDM
		ENDIF		
	ELSE
		rbpFrame=1
		rspFrame=0
		push rbp
		mov rbp,rsp
		IFDEF __chkstk
			mov rax,allbytes
			call __chkstk
			sub rsp,rax
		ELSE
			sub rsp,allbytes
		ENDIF
		rbpFirstArgBias=allbytes
		allbytes=allbytes-8*MaxInvokeParms
		IFNB <reglist>
			FOR reg,reglist
				mov [rbp-allbytes],reg
				allbytes=allbytes-8
			ENDM
		ENDIF
    ENDIF  
	EXITM <localbytes>
ENDM
rbpFrameEpilogue MACRO procname,flags,argbytes,localbytes,reglist,userparms:VARARG
LOCAL RegCnt,RegSize,MaxInvokeParms,allbytes
	RegCnt=0
	IFNB <reglist>
	    FOR reg,reglist
	    	RegCnt=RegCnt+1
	    ENDM
    ENDIF
    MaxInvokeParms=DefaultInvokeArgs
    IFNB <userparms>
    	MaxInvokeParms=@CatStr(%userparms)
    ENDIF
    allbytes=localbytes+8*(RegCnt+MaxInvokeParms)
    IF (allbytes AND 7) NE 0
    	allbytes=allbytes-(allbytes AND 7)+8
    ENDIF
    IF (allbytes AND 8) NE 0
    	allbytes=allbytes+8
    ENDIF
    IF (localbytes+argbytes-8) EQ 0
		allbytes=8*(RegCnt+MaxInvokeParms)
		IF (allbytes AND 8) EQ 0
			allbytes=(8*MaxInvokeParms)+8
		ELSE
			allbytes=8*MaxInvokeParms
		ENDIF
		IFDIF reglist,<>
			add rsp,allbytes
			FOR reg,reglist
				pop reg
			ENDM
		ENDIF	
	ELSE
		allbytes=allbytes-8*(MaxInvokeParms+RegCnt)
		IFNB <reglist>
			FOR reg,reglist
				allbytes=allbytes+8
				mov reg,[rbp-allbytes]
			ENDM
		ENDIF
		leave
    ENDIF
    IF JustLeaveFrame EQ 0
		db 0C3h
	ENDIF
ENDM
MaxArgs MACRO ArgsNum
	sub rsp,8*ArgsNum
	.if rsp&0Fh
		sub rsp,8
	.endif
ENDM
FillStack = 1
;;rbpFirstArgBias
invoke MACRO procname,args:VARARG
LOCAL numics,is_addr	
	txt TEXTEQU <>
	ArgNum = 0
%	FOR item, <args>
		IF ArgNum EQ 0
			register rcx,item
		ELSEIF ArgNum EQ 1
			register rdx,item
		ELSEIF ArgNum EQ 2
			register r8,item
		ELSEIF ArgNum EQ 3
			register r9,item
		ELSE
			txt CATSTR <item>,<!,>,txt
		ENDIF
%		ArgNum=ArgNum+1
	ENDM
	IF rbpFrame EQ 1
;;		echo I`m here...
		IF ArgNum GT 4
			txt SUBSTR  txt, 1, @SizeStr( %txt ) - 1
			ArgNum=rbpFirstArgBias-8*ArgNum
		%	FOR item,<txt>
				ArgNum=ArgNum+8
				numics=IS_INT_REG(%@CatStr(< >,ToLower(item),< >))
			%	IF numics NE 0
					mov [rbp-ArgNum],item
				ELSE
;;				%	echo it`s not reg item
					numics=@SizeStr(<item>)
					;;%echo item sizec=@CatStr(%numics)
					IF numics GT 4
						numics=0
						is_addr TEXTEQU ToLower(%@SubStr(<item>,1,5))
						IFIDN is_addr,<addr >
							numics=1
						ENDIF
					ELSE
						numics=0
					ENDIF
					IF numics NE 0
						lea rax,@SubStr(<item>,6,@SizeStr(<item>)-5)
						mov [rbp-ArgNum],rax
						;;%echo 6666666666666
					ELSEIF (((OPATTR item) AND 2) NE 0) AND (((OPATTR item) AND 4) NE 0)
;;						echo offsetic
						mov rax,item
						mov [rbp-ArgNum],rax
					ELSEIF (OPATTR item) AND 4 ;;Is an immediate expression
						numics=@CatStr(%(item))
						IF (numics GT 7FFFFFFFh) OR (numics LT -7FFFFFFFh)
							mov rax,item
							mov [rbp-ArgNum],rax
						ELSE
							mov qword ptr [rbp-ArgNum],item
						ENDIF
					ELSEIF (OPATTR item) AND 2
;;						echo it`s a mem...
						IF (TYPE item) EQ 1
							mov al,item
							mov [rbp-ArgNum],al
						ELSEIF (TYPE item) EQ 2
							mov ax,item
							mov [rbp-ArgNum],ax
						ELSEIF (TYPE item) EQ 4
							mov eax,item
							mov [rbp-ArgNum],eax
						ELSEIF (TYPE item) EQ 8
							mov rax,item
							mov [rbp-ArgNum],rax
						ELSEIF (TYPE item) EQ 16
							mov rax,qword ptr item
							mov rdx,qword ptr item[8]
							mov [rbp-ArgNum],rax
							mov [rbp-ArgNum][8],rdx
							ArgNum=ArgNum+8
						ENDIF
					ENDIF
				ENDIF			
			ENDM	
		ENDIF
		call procname
	ELSEIF rspFrame EQ 1
		IF ArgNum GT 4
			txt SUBSTR  txt, 1, @SizeStr( %txt ) - 1
		%	FOR item,<txt>
				ArgNum = ArgNum-1
				;;%echo item
				IF IS_INT_REG(< item >) NE 0
					mov [rsp+8*ArgNum],item
				ELSE
					IF (@InStr(1,<0123456789>,@SubStr(<item>,1,1)) NE 0) AND (@SizeStr(<item>) LE 10)
						mov qword ptr [rsp+8*ArgNum],item
					ELSE
						IF ( (@SizeStr(<item>) GE 4) AND (@InStr(1,<item>,<addr >) EQ 1) ) ;;OR (@SubStr(item,1,4),<ADDR>) ;;OR (@SubStr(item,1,4),<Addr>)
							lea rax,@SubStr(<item>,6,@SizeStr(<item>)-5)
						ELSE
							mov rax,item
						ENDIF
						mov [rsp+8*ArgNum],rax
					ENDIF
				ENDIF
			ENDM
		ENDIF
		call procname
	ELSE
		IF ArgNum GT 4
			txt SUBSTR  txt, 1, @SizeStr( %txt ) - 1
			%pushm txt
		ENDIF
		sub rsp,8*4
		call procname
		IF ArgNum GT 4
			add rsp,8*ArgNum
		ELSE
			add rsp,8*4
		ENDIF
	ENDIF	
ENDM
GetVal MACRO NumStr:REQ
%	EXITM <NumStr>
ENDM
CONSTANT MACRO string:VARARG
.const
	string
.code
ENDM
STATIC MACRO string:VARARG
.data
	string
.code
ENDM
RESERV MACRO string:VARARG
.data?
align 8
	string
.code
ENDM
unicode MACRO page,string,zero
LOCAL Zstr
	%	FORC char,<string>
			Zstr CATSTR <db '>,<char>,<',>,<page>
		%	Zstr
		ENDM
	%	IFDIF <zero>,<>
			Zstr CATSTR <dw >,<zero>
		%	Zstr
		ENDIF
ENDM